//Шина сообщений приложения

//События:
//termSelected - выбран термин - нагрузка - id выбранного термина
//searchClick - запущен поиск по строке  - нагрузка - строка поиска
//editTerm - запущено редактирование или создание термина -
//                         в случае редактирования нагрузка - объект редактируемого термина
//                         в случае создания - ничего

class Broker {
    constructor() {
        // массивы подписчиков привязанные к каждому топику
        this.subscribers = {};
    }

    // метод подписки
    onEvent(topic, data) {
        if (!this.subscribers[topic])
            {
             this.subscribers[topic] = [];
            }  
        this.subscribers[topic].push(data);
    }

    // метод оповещения подписчиков
    storeEvent(topic, data) {
        if (this.subscribers[topic]) {
            this.subscribers[topic].forEach(item => item(data));
            console.log(`topic:${topic} data:${data}`);
        }
    }
}

//глобальный объект, который связывает публикаторов и подписчиков
let broker = new Broker();

export default broker;