import React from "react";
import { Button, AutoComplete } from "antd";
import "./App.css";
import axios from "axios";
import broker from "./Broker.js";

//Строка поиска с автодополнением по первым буквам наименования термина

const { Option } = AutoComplete;

export class SearchString extends React.Component {
  state = {
    autoCompliteVals: [],
    currentValue: ""
  };

  constructor(props) {
    super(props);
    broker.onEvent("termSelected", data => this.onTermSelected());
  }

  onTermSelected = () => {
    //todo очистка поля поиска при выборе из дерева
    //обернуть в Form и исп FormResetFields?
  };

  handleSearch = value => {
    //получаем варианты для AutoComplite на основе введенного значения
    this.currentValue = value;
    let autoCompliteVals = [];
    if (value) {
      axios.get(`/getTermsNamesforAC/${value}`).then(res => {
        const data = res.data;
        data.forEach(item => {
          autoCompliteVals.push(String(item.name));
        });
        this.setState({ autoCompliteVals });
      });
    }
  };

  onSelect = value => {
    //уведомляем приложение о запуске поиска при выборе варианта AC
    this.currentValue = value;
    if (value.length > 0) {
      broker.storeEvent("searchClick", value);
    }
  };

  searchClick = () => {
    //уведомляем приложение о запуске поиска при клике на кнопку
    broker.storeEvent("searchClick", String(this.currentValue));
  };

  render() {
    const { autoCompliteVals } = this.state;
    const selectChildrens = autoCompliteVals.map(autoCompliteVal => (
      <Option key={autoCompliteVal}>{autoCompliteVal}</Option>
    ));
    return (
      <div className="global-search-wrapper">
        <AutoComplete
          style={{ width: 600 }}
          onSearch={this.handleSearch}
          onSelect={this.onSelect}
          placeholder="Введите наименование термина"
        >
          {selectChildrens}
        </AutoComplete>
        <Button type="primary" onClick={this.searchClick}>
          Найти
        </Button>
      </div>
    );
  }
}
