﻿import React from "react";
import { Typography, Icon, Card } from "antd";
import "./App.css";
import broker from "./Broker.js";
import sources from "./Sources.js";

//Карточка термина (для отображения)

const { Title, Text } = Typography;

export class TermCard extends React.Component {
  onEditTermClick = value => {
    broker.storeEvent("editTerm", value);
  };

  render() {
    const { term } = this.props;
    const { descriptions } = term;
    const termShownTitle = (
      <Text>
        <Title level={3}>{term.name}</Title>
        <Text type="secondary">{term.abbreviation}</Text>
        <br />
        <Text>{term.enName}</Text>
      </Text>
    );
    const termShownDescriptions = descriptions.map(description => (
      <Text id={description.id} key={description.id}>
        <Text type="strong"> - {description.text}</Text>
        <br />
        <Text type="secondary">
          {sources.getSouceDatabyId(description.sourceId)}
        </Text>
        <br />
      </Text>
    ));
    return (
      <Card
        id={term.id}
        key={term.id}
        title={termShownTitle}
        extra={[
          <Icon
            type="edit"
            key="edit"
            onClick={() => this.onEditTermClick(term)}
          />
        ]}
        style={{ width: "100v" }}
      >
        {termShownDescriptions}
      </Card>
    );
  }
}
