const term = require("./term.model.js");

//обработка ошибок только в нескольких местах, для примера, дальше опущено для краткости

//возвращает термин по его id
exports.getTerm = (req, res) => {
  term.getTerm(req.params.termId, (err, data) => {
    if (err) {
      if (err.kind === "not_found") {
        res.status(404).send({
          message: `Not found term with id ${req.params.termId}.`
        });
      } else {
        res.status(500).send({
          message: `Error retrieving term with id ${req.params.termId}`
        });
      }
    } else res.send(data);
  });
};

//возвращает набор терминов вхождению фразы searchString в название
exports.getTermsbySearchString = (req, res) => {
  term.getTermsbySearchString(req.params.searchString, (err, data) => {
    if (err) {
      if (err.kind === "not_found") {
        res.status(404).send({
          message: `Not found terms by searchString ${req.params.searchString}.`
        });
      } else {
        res.status(500).send({
          message: `Error retrieving terms by searchString ${req.params.searchString}`
        });
      }
    } else res.send(data);
  });
};

//создание или изменение термина
exports.storeTerm = (req, res) => {
  term.storeTerm(req.body, (err, data) => {
    res.send(data);
  });
};

//удаление термина из БД по его id
exports.deleteTerm = (req, res) => {
  term.deleteTerm(req.params.termId, (err, data) => {
    res.send(data);
  });
};

//возвращает набор первых букв названий всех терминов
exports.getTermsNamesFls = (req, res) => {
  term.getTermsNamesFls((err, data) => {
    res.send(data);
  });
};

//возвращает набор терминов начинающихся на определенную букву
exports.getTermsNamesByFl = (req, res) => {
  term.getTermsNamesByFl(req.params.termFl, (err, data) => {
    res.send(data);
  });
};

//возвращает список наименований терминов , начинающихся на searchString
exports.getTermsNamesforAC = (req, res) => {
  term.getTermsNamesforAC(req.params.searchString, (err, data) => {
    res.send(data);
  });
};

//получение справочника источников описаний
exports.getSources = (req, res) => {
  term.getSources((err, data) => {
    res.send(data);
  });
};
