module.exports = api => {
    const terms = require("./terms.controller.js");

    //возвращает термин по его id
    api.get("/getTerm/:termId", terms.getTerm);

    //возвращает набор терминов вхождению фразы searchString в название
    api.get("/getTermsbySearchString/:searchString", terms.getTermsbySearchString);

    //создание или изменение термина
    api.post("/storeTerm", terms.storeTerm);

    //удаление термина из БД по его id
    api.get("/deleteTerm/:termId", terms.deleteTerm);

    //возвращает набор первых букв названий всех терминов
    api.get("/getTermsNamesFls", terms.getTermsNamesFls);

    //возвращает набор терминов начинающихся на определенную букву
    api.get("/getTermsNamesByFl/:termFl", terms.getTermsNamesByFl);

    //возвращает список наименований терминов, начинающихся на searchString
    api.get("/getTermsNamesforAC/:searchString", terms.getTermsNamesforAC);

    //получение справочника источников описаний терминов
    api.get("/getSources", terms.getSources);
};