const express = require("express");
const bodyParser = require("body-parser");
var cors = require ('cors')

const api = express();

// parse requests of content-type - application/json
api.use(bodyParser.json());

// parse requests of content-type - application/x-www-form-urlencoded
api.use(bodyParser.urlencoded({ extended: true }));

//add cors headers
api.use(cors());

//root route
api.get("/", (req, res) => {
  res.json({ message: "Welcome to terms application." });
});

//define api routes
require("./app/terms.routes.js")(api);

// set port, listen for requests
const PORT = process.env.PORT || 8080;
api.listen(PORT, () => {
  console.log(`Server is running on port ${PORT}.`);
});
